Bug 197039 - V1-format (*.gz) Nexus indices cannot be fetched from Apache httpd
V1-format (*.gz) Nexus indices cannot be fetched from Apache httpd
Status: VERIFIED FIXED
Product: projects
Classification: Unclassified
Component: Maven
7.0
PC Linux
: P2 (vote)
: 7.0
Assigned To: Jesse Glick
issues@projects
http://jira.codehaus.org/browse/MINDE...
: 70_HR_FIX
Depends on:
Blocks: 191685
  Show dependency treegraph
 
Reported: 2011-03-24 14:30 UTC by Jesse Glick
Modified: 2011-03-30 15:24 UTC (History)
4 users (show)

See Also:
Issue Type: DEFECT
:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Jesse Glick 2011-03-24 14:30:45 UTC
Due to a bug in Maven Indexer (see URL), a repository index using the new GZIPped format cannot be downloaded by NB when the HTTP server sets Content-Encoding: gzip. http://jira.codehaus.org/browse/MINDEXER-12 also masks the original problem, which is why it took so long to notice. Does not affect Nexus mirrors (at least from the client; not sure what Nexus itself downloads), but does affect bits.netbeans.org. Forces us to publish a *.zip fallback index, which is a bigger download and does not support incremental downloads.

Since older IDE releases will not have the fix, still need to publish both formats. https://bitbucket.org/jglick/nexus-for-netbeans/changeset/eb8d43bab322 accomplishes that. (Currently we publish only the *.zip because of this bug. After the fix, an older IDE will actually download the *.gz index, fail to read it, then download the *.zip; oh well.)
Comment 1 Jesse Glick 2011-03-24 15:01:58 UTC
core-main #62df07c4a7a6
Comment 2 Marian Mirilovic 2011-03-24 15:10:17 UTC
(In reply to comment #1)
> core-main #62df07c4a7a6

Jesse, i agree with integration. Please do that before 10pm CET today, so we will ask NetCAT to test it during the weekend. Thanks in advance.
Comment 3 Jesse Glick 2011-03-24 23:21:24 UTC
releases #92b966499c63 though after your deadline.
Comment 4 Quality Engineering 2011-03-25 09:53:41 UTC
Integrated into 'main-golden', will be available in build *201103250400* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main/rev/62df07c4a7a6
User: Jesse Glick <jglick@netbeans.org>
Log: #197039: V1-format (*.gz) Nexus indices cannot be fetched from Apache httpd
Comment 5 Tomas Danek 2011-03-25 10:07:09 UTC
If I understand correctly, http://bits.netbeans.org/maven2/ now supports *.gz index, and ide after core-main #62df07c4a7a6 knows how to handle it (with fallback to *.zip)?
For main maven2 repo has nothing changed?
Comment 6 Tomas Danek 2011-03-28 14:27:02 UTC
it seems like it's working properly, i was able to obtain index from all default repositories.

v.

Product Version: NetBeans IDE 7.0 RC1 (Build 201103280000)
Java: 1.6.0_24; Java HotSpot(TM) 64-Bit Server VM 19.1-b02-334
System: Mac OS X version 10.6.7 running on x86_64; MacRoman; en_US (nb)
Userdir: /Users/tomas/.netbeans/7.0rc1
Comment 7 Jesse Glick 2011-03-28 20:24:22 UTC
(In reply to comment #5)
> If I understand correctly, http://bits.netbeans.org/maven2/ now supports *.gz
> index

Yes.

> and ide after core-main #62df07c4a7a6 knows how to handle it

The IDE has long been able to handle *.gz indices (Central publishes one), but it was served incorrectly from our Apache server. With this fix, the IDE should be able to retrieve even the misserved *.gz index.

Additionally, we found the misconfiguration in the server and corrected it, so previous IDE versions should now be able to use the new-style index too.

> (with fallback to *.zip)?

In case *.gz is missing, the Indexer falls back to *.zip. Unfortunately this logic was broken in some older versions of the Indexer, including that used in Beta 2 IIRC, causing it to fail utterly if the *.gz was misserved even if the *.zip was present and valid.

(Sorry this is so complicated to verify, but the problem was in the interaction between client and server.)

> For main maven2 repo has nothing changed?

Not that I know of.
Comment 8 Jesse Glick 2011-03-30 15:24:31 UTC
Update: MINDEXER-12 and MINDEXER-13 accepted upstream and should be in Maven Indexer 4.1.0; also related MINDEXER-20 (robustness against bad input) was applied.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2012, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo